#include <Wire.h>
#include <Adafruit_PWMServoDriver.h>

Adafruit_PWMServoDriver pwm = Adafruit_PWMServoDriver();

#define SERVOMIN 500
#define SERVOMAX 2500
#define SERVOMIN11  500
#define SERVOMAX11  2500
#define SERVOMIN12  500
#define SERVOMAX12  4500
#define SERVOMIN13  500
#define SERVOMAX13  2500
#define SERVOMIN14  500
#define SERVOMAX14  2830
#define F_EnA 3
#define F_in1 A3
#define F_in2 A2
#define F_in3 A1
#define F_in4 A0
#define F_EnB 2
#define M_EnA 4
#define M_in1 A5
#define M_in2 A4
#define M_in3 A6
#define M_in4 A7
#define M_EnB 5
#define B_EnA 7
#define B_in1 A10
#define B_in2 A9
#define B_in3 A8
#define B_in4 A15
#define B_EnB 6
#define pinCanal1 9
#define pinCanal2 11
#define pinCanal3 12
#define pinCanal4 13
#define pinCanal5 8
#define Canal2_middle_min 1470
#define Canal2_middle_max 1500
#define Canal4_middle_min 1470
#define Canal4_middle_max 1500



int leftSpeed = 200;
int rightSpeed = 200;

long Canal1Time;
long Canal2Time;
long Canal3Time;
long Canal4Time;
long Canal5Time;


void left_forward() {
  digitalWrite(F_in1, LOW);
  digitalWrite(F_in2, HIGH);
  analogWrite(F_EnA, leftSpeed);
  digitalWrite(M_in1, HIGH);
  digitalWrite(M_in2, LOW);
  analogWrite(M_EnA, leftSpeed);
  analogWrite(B_EnA, leftSpeed);
  digitalWrite(B_in1, LOW);
  digitalWrite(B_in2, HIGH);


}
void right_forward() {
  digitalWrite(F_in3, HIGH);
  digitalWrite(F_in4, LOW);
  analogWrite(F_EnB, rightSpeed);
  digitalWrite(M_in3, LOW);
  digitalWrite(M_in4, HIGH);
  analogWrite(M_EnB, rightSpeed);
  digitalWrite(B_in3, HIGH);
  digitalWrite(B_in4, LOW);
  analogWrite(B_EnB, rightSpeed);
}

void left_back() {
  digitalWrite(F_in1, HIGH);
  digitalWrite(F_in2, LOW);
  analogWrite(F_EnA, leftSpeed);
  digitalWrite(M_in1, LOW);
  digitalWrite(M_in2, HIGH);
  analogWrite(M_EnA, leftSpeed);
  analogWrite(B_EnA, leftSpeed);
  digitalWrite(B_in1, HIGH);
  digitalWrite(B_in2, LOW);

}

void right_back() {
  digitalWrite(F_in3, LOW);
  digitalWrite(F_in4, HIGH);
  analogWrite(F_EnB, rightSpeed);
  digitalWrite(M_in3, HIGH);
  digitalWrite(M_in4, LOW);
  analogWrite(M_EnB, rightSpeed);
  digitalWrite(B_in3, LOW);
  digitalWrite(B_in4, HIGH);
  analogWrite(B_EnB, rightSpeed);
}
void right_stop() {
  digitalWrite(F_in3, HIGH);
  digitalWrite(F_in4, HIGH);
  digitalWrite(M_in3, HIGH);
  digitalWrite(M_in4, HIGH);
  digitalWrite(B_in3, HIGH);
  digitalWrite(B_in4, HIGH);

}

void left_stop() {
  digitalWrite(F_in1, HIGH);
  digitalWrite(F_in2, HIGH);
  digitalWrite(M_in1, HIGH);
  digitalWrite(M_in2, HIGH);
  digitalWrite(B_in1, HIGH);
  digitalWrite(B_in2, HIGH);
}

void robot_forward() {
  left_forward();
  right_forward();
}
void robot_stop() {
  left_stop();
  right_stop();
}

void robot_back() {
  right_back();
  left_back();
}
void robot_turn_left() {
  left_back();
  right_forward();
}
void robot_turn_right() {
  left_forward();
  right_back();
}

boolean is_Canal2_in_middle() {
  if ((Canal2Time > Canal2_middle_min) && (Canal2Time < Canal2_middle_max)) {
    return true;
  } else {
    return false;
  }
}
boolean is_Canal4_in_middle() {
  if ((Canal4Time > Canal4_middle_min) && (Canal4Time < Canal4_middle_max)) {
    return true;
  } else {
    return false;
  }
}

void check_and_stop() {
  if ((is_Canal2_in_middle()) && (is_Canal4_in_middle())) {
    robot_stop();
  }
}

void setup() {
  // put your setup code here, to run once:
  pinMode(F_EnA, OUTPUT);
  pinMode(F_EnB, OUTPUT);
  pinMode(F_in1, OUTPUT);
  pinMode(F_in2, OUTPUT);

  pinMode(F_in3, OUTPUT);
  pinMode(F_in4, OUTPUT);
  pinMode(M_EnA, OUTPUT);
  pinMode(M_EnB, OUTPUT);
  pinMode(M_in1, OUTPUT);
  pinMode(M_in2, OUTPUT);
  pinMode(M_in3, OUTPUT);
  pinMode(M_in4, OUTPUT);
  pinMode(B_EnA, OUTPUT);
  pinMode(B_EnB, OUTPUT);
  pinMode(B_in1, OUTPUT);
  pinMode(B_in2, OUTPUT);
  pinMode(B_in3, OUTPUT);
  pinMode(B_in4, OUTPUT);
  Serial.begin(9600);
  pinMode(pinCanal1, INPUT);
  pinMode(pinCanal2, INPUT);
  pinMode(pinCanal3, INPUT);
  pinMode(pinCanal4, INPUT);
  pwm.begin();         // Sends PWM signals.
  pwm.setPWMFreq(300);  // Makes servos run at 60 Hz rate.
  delay(20);
  robot_stop();
}

void loop() {

  long mic;
  mic = micros();

  Canal1Time = pulseIn(pinCanal1, HIGH);    // нижняя
  Canal2Time = pulseIn(pinCanal2, HIGH);      // поворот захвата
  Canal3Time = pulseIn(pinCanal3, HIGH);      // захват
  Canal4Time = pulseIn(pinCanal4, HIGH);      // средняя
  Canal5Time = pulseIn(pinCanal5, HIGH);
  mic = micros() - mic;
  Serial.print(mic); Serial.print(" = ");
  Serial.print(Canal1Time); Serial.print(" = ");
  Serial.print(Canal2Time); Serial.print(" = ");
  Serial.print(Canal3Time); Serial.print(" = ");
  Serial.print(Canal4Time); Serial.print(" || ");
  Serial.print(Canal5Time); Serial.print(" = ");
  Serial.println(" =================================== ");


  int robot_mode = Canal5Time;
  if (Canal5Time > 1500) {

    if ((Canal2Time == 0) && (Canal1Time == 0) && (Canal3Time == 0) && (Canal4Time == 0)) {
      robot_stop();
    } else {
      if (Canal2Time > Canal2_middle_max) {
        rightSpeed = map(Canal2Time, Canal2_middle_max, 1987, 0, 255);
        leftSpeed = map(Canal2Time, Canal2_middle_max, 1987, 0, 235);
        robot_forward();
      }
      else if (Canal2Time < Canal2_middle_min) {
        rightSpeed = map(Canal2Time, Canal2_middle_min, 980, 0, 255);
        leftSpeed = map(Canal2Time, Canal2_middle_min, 980, 0, 235);
        robot_back();

      } else {
        check_and_stop();
      }
      if (Canal4Time > Canal4_middle_max) {
        rightSpeed = map(Canal4Time, Canal4_middle_max, 1987, 0, 255);
        leftSpeed = map(Canal4Time, Canal4_middle_max, 1987, 0, 255);
        robot_turn_right();
      } else if (Canal4Time < Canal4_middle_min) {
        rightSpeed = map(Canal4Time, Canal4_middle_min, 987, 0, 255);
        leftSpeed = map(Canal4Time, Canal4_middle_min, 987, 0, 255);
        robot_turn_left();
      }
      else {
        check_and_stop();
      }
    }
  } else {
    robot_stop();
    /*
      for (int pulselen = SERVOMIN; pulselen < SERVOMAX; pulselen++) // Drives each servo one at a time first
      {
      pwm.setPWM( 11 , 0, pulselen);
      pwm.setPWM(12, 0, pulselen);
      pwm.setPWM(13, 0, pulselen);
      pwm.setPWM(14, 0, pulselen);
      }
      delay(30);

      for (int pulselen = SERVOMAX; pulselen > SERVOMIN; pulselen--)
      {
      pwm.setPWM(11, 0, pulselen);
      pwm.setPWM(12, 0, pulselen);
      pwm.setPWM(13, 0, pulselen);
      pwm.setPWM(14, 0, pulselen);
      }
      delay(30);
    */

    int pulselen = map (Canal3Time, 1950, 980, SERVOMIN11, SERVOMAX11);
    pwm.setPWM( 11 , 0, pulselen);

    pulselen = map (Canal2Time, 979, 1957, SERVOMIN12, SERVOMAX12);
    pwm.setPWM( 12 , 0, pulselen);

    pulselen = map (Canal4Time, 979, 1954, SERVOMIN13, SERVOMAX13);
    pwm.setPWM( 13 , 0, pulselen);

    pulselen = map (Canal1Time, 980, 1950, SERVOMIN14, SERVOMAX14);
    pwm.setPWM( 14 , 0, pulselen);

  }

}
